﻿var Notiflix_Forguncy = (function (_super) {
    __extends(Notiflix_Forguncy, _super);

    function Notiflix_Forguncy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }

    var Notiflix_Color = ["Success", "Failure", "Warning", "Info"]
    var Notiflix_Position = ["right-top", "right-bottom", "left-top", "left-bottom", "center-top", "center-bottom", "center-center"]
    var Notiflix_LoadingIcon = ["Standard", "Hourglass", "Circle", "Arrows", "Dots", "Pulse", "Custom"]

    Notiflix_Forguncy.prototype.execute = function () {
        // Get settings
        var commandSettings = this.CommandParam;

        //弹窗类型
        var NotiflixType = commandSettings.NotiflixType;

        //弹窗位置
       var  position = Notiflix_Position[commandSettings.NotiflixPosition];

        //标题内容
       var  title = this.evaluateFormula(commandSettings.NotiflixTitle);

        //OK按钮内容
        var okButton = this.evaluateFormula(commandSettings.NotiflixOkbutton);

        //NO按钮内容
        var noButton = this.evaluateFormula(commandSettings.NotiflixNobutton);

        //持续时间
        var timeout = commandSettings.NotiflixTimeout;

        //消息内容
        var msg = this.evaluateFormula(commandSettings.NotiflixMessage);

        //是否显示蒙版
        var backOverlay = commandSettings.NotiflixBackOverla;

        //是否显示ICON
        var useIcon = commandSettings.NotiflixIcon;

        //弹窗颜色类型
        var ColorText = Notiflix_Color[commandSettings.NotiflixColor];

        //是否解析HTML文本
        var plainText = !commandSettings.PlainText;

        //加载图标类型
        var LoadingIcon = Notiflix_LoadingIcon[commandSettings.NotiflixLoadingIcon];

        //自定义图标地址
        var customSvgUrl = this.evaluateFormula(commandSettings.CustomSvgUrl);

        //element对象名
        var elementName = this.evaluateFormula(commandSettings.ElementName);

        //开始/停止
        var StarOrStop = commandSettings.StarOrStop;

        var OkButtonCommands = commandSettings.OkButtonCommands;
        var NoButtonCommands = commandSettings.NoButtonCommands;

        //Forguncy.CellTypeBase.executeCommand(Okcommands)

        var NotiflixOption = {
            plainText,
            titleMaxLength: 128,
            messageMaxLength: 512,
            backOverlay
        }

        switch (NotiflixType) {
            case 0:
                console.log('OkButtonCommands=',OkButtonCommands)
                Notiflix.Notify.Init({});
                Notiflix.Notify.Merge({
                    ...NotiflixOption,
                    useIcon,
                    position,
                    timeout
                });

                Notiflix.Notify[ColorText](
                    msg,
                    OkButtonCommands == undefined ? null : () => { this.CommandExecutor.excuteCommand(OkButtonCommands)}
                    );
                break;
            case 1:
                Notiflix.Report.Init({});
                Notiflix.Report.Merge({
                    ...NotiflixOption,
                });
                Notiflix.Report[ColorText](
                    title,
                    msg,
                    okButton,
                    OkButtonCommands == undefined ? null : () => { this.CommandExecutor.excuteCommand(OkButtonCommands) }
                );
                break;
            case 2:
                Notiflix.Confirm.Init({});
                Notiflix.Confirm.Merge({
                    ...NotiflixOption,
                });
                Notiflix.Confirm.Show(title, msg, okButton, noButton,
                    OkButtonCommands == undefined ? null : () => { this.CommandExecutor.excuteCommand(OkButtonCommands) },
                    NoButtonCommands == undefined ? null : () => { this.CommandExecutor.excuteCommand(NoButtonCommands) }
                );
                break;
            case 3:
                Notiflix.Loading.Init({});
                Notiflix.Loading.Merge({
                    ...NotiflixOption,
                    customSvgUrl,
                    svgSize:'80px'
                });
                StarOrStop ? Notiflix.Loading[LoadingIcon](msg) : Notiflix.Loading.Remove(timeout);
                break;
            case 4:
                Notiflix.Block.Init({});
                Notiflix.Block.Merge({
                    ...NotiflixOption
                });

                StarOrStop ? Notiflix.Block[LoadingIcon](elementName,msg) : Notiflix.Block.Remove(elementName, timeout);;
                break;
            default:
                alert("请选择弹窗类型!")
                break;
        }

    };
    return Notiflix_Forguncy;
}(Forguncy.CommandBase));

// Key format is "Namespace.ClassName, AssemblyName"
Forguncy.CommandFactory.registerCommand("Notiflix_Forguncy.Notiflix_Forguncy, Notiflix_Forguncy", Notiflix_Forguncy);